#include "PM.h"

PM::PM(int objects)
{
	this->size = objects;
	this->colliding = new bool*[objects];
	for(int i = 0; i < objects; ++i)
	{
		this->colliding[i] = new bool[objects];
		for(int j = 0; j < objects; ++j)
		{
			this->colliding[i][j] = false;
		}
	}
}
bool PM::is_colliding(AABB * obj1)
{
	for(int i = 0; i < this->size; ++i)
	{
		if(colliding[obj1->id][i] && colliding[i][obj1->id]) return true;
	}
	return false;
}

bool PM::is_semicolliding(AABB * obj1)
{
	for(int i = 0; i < this->size; ++i)
	{
		if(colliding[obj1->id][i] || colliding[i][obj1->id]) return true;
	}
	return false;
}

void PM::setXCollision(AABB * obj1, AABB * obj2)
{
	int o1 = obj1->id;
	int o2 = obj2->id;
	if(o1 == o2 || o1 < 0 || o2 < 0 || o1 >= this->size || o2 >= this->size) return;
	int first = (o1 < o2) ? o1 : o2;
	int second = (o1 > o2) ? o1 : o2;
	colliding[first][second] = true;
}

void PM::setYCollision(AABB * obj1, AABB * obj2)
{
	int o1 = obj1->id;
	int o2 = obj2->id;
	if(o1 == o2 || o1 < 0 || o2 < 0 || o1 >= this->size || o2 >= this->size) return;
	int first = (o1 > o2) ? o1 : o2;
	int second = (o1 < o2) ? o1 : o2;
	colliding[first][second] = true;
}

void PM::resetXCollision(AABB * obj1, AABB * obj2)
{
	int o1 = obj1->id;
	int o2 = obj2->id;
	if(o1 == o2 || o1 < 0 || o2 < 0 || o1 >= this->size || o2 >= this->size) return;
	int first = (o1 < o2) ? o1 : o2;
	int second = (o1 > o2) ? o1 : o2;
	colliding[first][second] = false;
}

void PM::resetYCollision(AABB * obj1, AABB * obj2)
{
	int o1 = obj1->id;
	int o2 = obj2->id;
	if(o1 == o2 || o1 < 0 || o2 < 0 || o1 >= this->size || o2 >= this->size) return;
	int first = (o1 > o2) ? o1 : o2;
	int second = (o1 < o2) ? o1 : o2;
	colliding[first][second] = false;
}

int PM::all_collisions()
{
	int sum = 0;
	for(int i = 0; i < this->size-1; ++i)
	{
		for(int j = i+1; j < this->size; ++j)
		{
			if(colliding[i][j] && colliding[j][i])
			{
				sum++;
			}
		}
	}
	return sum;
}
