#include "bruteForce.h"
#include "physicalWorld.h"
#include "AABB.h"

BruteForce::BruteForce()
{

}


bool BruteForce::is_colliding(AABB* box)
{
	for(int i = 0; i < world->boxes->size(); ++i)
	{
		AABB *tmp = world->boxes->at(i);
		if(tmp->id == box->id) continue;
		if(
			((tmp->xStart < box->xStart && tmp->xEnd > box->xStart) || (tmp->xStart < box->xEnd && tmp->xEnd > box->xEnd)) &&
			((tmp->yStart < box->yStart && tmp->yEnd > box->yStart) || (tmp->yStart < box->yEnd && tmp->yEnd > box->yEnd))
		) {
			return true;
		}
	}
}

int BruteForce::all_collisions()
{
	int sum = 0;
	for(int i = 0; i < world->boxes->size()-1; ++i)
	{
		AABB *tmp = world->boxes->at(i);
		for(int j = i+1; j < world->boxes->size(); ++j)
		{
			AABB *box = world->boxes->at(j);
			if(tmp->id == box->id) continue;
			if(
				((tmp->xStart < box->xStart && tmp->xEnd > box->xStart) || (tmp->xStart < box->xEnd && tmp->xEnd > box->xEnd)) &&
				((tmp->yStart < box->yStart && tmp->yEnd > box->yStart) || (tmp->yStart < box->yEnd && tmp->yEnd > box->yEnd))
			) {
				sum++;
			}
		}
	}
	return sum;
}

