//#ifndef MAINWINDOW_H
//#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QtGui/QGraphicsScene>
#include <QtGui/QBrush>
#include <QtGui/QPen>
#include <QtCore/QTimer>
#include <QtGui/QGraphicsRectItem>

#include "mainwindow_ui.h"
#include "PM.h"
#include "physicalWorld.h"
#include "sweepAndPrune.h"
#include "bruteForce.h"


namespace Ui
{
	class MainWindowClass;
}


class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	MainWindow(QWidget *parent = 0);
	QGraphicsScene *sc;
	QTimer *timer;

	Ui::MainWindowClass *ui;
	
	physicalWorld *world;
	SweepAndPrune *SAP;
	BruteForce *BF;
	PM *pmanagement;
	QGraphicsRectItem **boxes;
	
public slots:
	void timeout();
};

//#endif