#include "physicalWorld.h"
#include "AABB.h"

physicalWorld::physicalWorld()
{
}

physicalWorld::physicalWorld(int width, int height, float dt)
{
	this->width = width;
	this->height = height;
	this->dt = dt;
	boxes = new std::vector<AABB *>(0);
}

void physicalWorld::addBox(int x, int y, int w, int h, float dx, float dy)
{
	boxes->push_back(new AABB(boxes->size(), x, y, w, h, dx, dy));
	SAP->updateListByAdding(boxes->at(boxes->size()-1));
}

void physicalWorld::removeBox (int id) {
	SAP->updateListByRemoving(boxes->at(id));
	boxes->erase(boxes->begin()+id);
}


void physicalWorld::step()
{
	for(int i = 0; i < boxes->size(); ++i)
	{
		float ndx = boxes->at(i)->dx * dt;
		float ndy = boxes->at(i)->dy * dt;
		if(ndx != 0. && ndy != 0.)
		{
			if((boxes->at(i)->xEnd+ndx) > this->width || (boxes->at(i)->xStart+ndx) < 0)
			{ // we are on the margin of the "world"
				ndx *= -1.;
				boxes->at(i)->dx *= -1.;
			}
			if((boxes->at(i)->yEnd+ndy) > this->height || (boxes->at(i)->yStart+ndy) < 0)
			{ // we are on the margin of the "world"
				ndy *= -1.;
				boxes->at(i)->dy *= -1.;
			}
			SAP->updateObject(boxes->at(i), ndx, ndy);
			boxes->at(i)->move(ndx, ndy);
		}
	}
}
